/**
 */
package org.eclipse.viatra.cep.core.metamodels.automaton.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra.cep.core.metamodels.automaton.AutomatonPackage;
import org.eclipse.viatra.cep.core.metamodels.automaton.EventToken;
import org.eclipse.viatra.cep.core.metamodels.automaton.ParameterBinding;
import org.eclipse.viatra.cep.core.metamodels.automaton.ParameterTable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Parameter Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.automaton.impl.ParameterTableImpl#getParameterBindings <em>Parameter Bindings</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.automaton.impl.ParameterTableImpl#getEventToken <em>Event Token</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ParameterTableImpl extends MinimalEObjectImpl.Container implements ParameterTable {
	/**
	 * The cached value of the '{@link #getParameterBindings() <em>Parameter Bindings</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getParameterBindings()
	 * @generated
	 * @ordered
	 */
	protected EList<ParameterBinding> parameterBindings;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParameterTableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutomatonPackage.Literals.PARAMETER_TABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ParameterBinding> getParameterBindings() {
		if (parameterBindings == null) {
			parameterBindings = new EObjectContainmentWithInverseEList<ParameterBinding>(ParameterBinding.class, this, AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS, AutomatonPackage.PARAMETER_BINDING__PARAMETER_TABLE);
		}
		return parameterBindings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventToken getEventToken() {
		if (eContainerFeatureID() != AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN) return null;
		return (EventToken)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEventToken(EventToken newEventToken, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newEventToken, AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventToken(EventToken newEventToken) {
		if (newEventToken != eInternalContainer() || (eContainerFeatureID() != AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN && newEventToken != null)) {
			if (EcoreUtil.isAncestor(this, newEventToken))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEventToken != null)
				msgs = ((InternalEObject)newEventToken).eInverseAdd(this, AutomatonPackage.EVENT_TOKEN__PARAMETER_TABLE, EventToken.class, msgs);
			msgs = basicSetEventToken(newEventToken, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN, newEventToken, newEventToken));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getParameterBindings()).basicAdd(otherEnd, msgs);
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetEventToken((EventToken)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				return ((InternalEList<?>)getParameterBindings()).basicRemove(otherEnd, msgs);
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				return basicSetEventToken(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				return eInternalContainer().eInverseRemove(this, AutomatonPackage.EVENT_TOKEN__PARAMETER_TABLE, EventToken.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				return getParameterBindings();
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				return getEventToken();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				getParameterBindings().clear();
				getParameterBindings().addAll((Collection<? extends ParameterBinding>)newValue);
				return;
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				setEventToken((EventToken)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				getParameterBindings().clear();
				return;
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				setEventToken((EventToken)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutomatonPackage.PARAMETER_TABLE__PARAMETER_BINDINGS:
				return parameterBindings != null && !parameterBindings.isEmpty();
			case AutomatonPackage.PARAMETER_TABLE__EVENT_TOKEN:
				return getEventToken() != null;
		}
		return super.eIsSet(featureID);
	}

} //ParameterTableImpl
