/**
 */
package org.eclipse.viatra.integration.xcore.model.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;
import org.eclipse.emf.ecore.xcore.XMember;
import org.eclipse.emf.ecore.xcore.XModelElement;
import org.eclipse.emf.ecore.xcore.XNamedElement;
import org.eclipse.emf.ecore.xcore.XPackage;
import org.eclipse.emf.ecore.xcore.XStructuralFeature;
import org.eclipse.emf.ecore.xcore.XTypedElement;
import org.eclipse.viatra.integration.xcore.model.XIncQueryDerivedFeature;
import org.eclipse.viatra.integration.xcore.model.XIncQueryImport;
import org.eclipse.viatra.integration.xcore.model.XIncQueryPackage;
import org.eclipse.viatra.integration.xcore.model.XcorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra.integration.xcore.model.XcorePackage
 * @generated
 */
public class XcoreSwitch<T> extends Switch<T> {
	/**
     * The cached model package
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected static XcorePackage modelPackage;

	/**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public XcoreSwitch() {
        if (modelPackage == null) {
            modelPackage = XcorePackage.eINSTANCE;
        }
    }

	/**
     * Checks whether this is a switch for the given package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @parameter ePackage the package in question.
     * @return whether this is a switch for the given package.
     * @generated
     */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
        return ePackage == modelPackage;
    }

	/**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case XcorePackage.XINC_QUERY_DERIVED_FEATURE: {
                XIncQueryDerivedFeature xIncQueryDerivedFeature = (XIncQueryDerivedFeature)theEObject;
                T result = caseXIncQueryDerivedFeature(xIncQueryDerivedFeature);
                if (result == null) result = caseXStructuralFeature(xIncQueryDerivedFeature);
                if (result == null) result = caseXMember(xIncQueryDerivedFeature);
                if (result == null) result = caseXTypedElement(xIncQueryDerivedFeature);
                if (result == null) result = caseXNamedElement(xIncQueryDerivedFeature);
                if (result == null) result = caseXModelElement(xIncQueryDerivedFeature);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case XcorePackage.XINC_QUERY_PACKAGE: {
                XIncQueryPackage xIncQueryPackage = (XIncQueryPackage)theEObject;
                T result = caseXIncQueryPackage(xIncQueryPackage);
                if (result == null) result = caseXPackage(xIncQueryPackage);
                if (result == null) result = caseXNamedElement(xIncQueryPackage);
                if (result == null) result = caseXModelElement(xIncQueryPackage);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case XcorePackage.XINC_QUERY_IMPORT: {
                XIncQueryImport xIncQueryImport = (XIncQueryImport)theEObject;
                T result = caseXIncQueryImport(xIncQueryImport);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XInc Query Derived Feature</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XInc Query Derived Feature</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXIncQueryDerivedFeature(XIncQueryDerivedFeature object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XInc Query Package</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XInc Query Package</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXIncQueryPackage(XIncQueryPackage object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XInc Query Import</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XInc Query Import</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXIncQueryImport(XIncQueryImport object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XModel Element</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XModel Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXModelElement(XModelElement object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XNamed Element</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XNamed Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXNamedElement(XNamedElement object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XTyped Element</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XTyped Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXTypedElement(XTypedElement object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XMember</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XMember</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXMember(XMember object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>XStructural Feature</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XStructural Feature</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseXStructuralFeature(XStructuralFeature object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>XPackage</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>XPackage</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseXPackage(XPackage object) {
        return null;
    }

	/**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
	@Override
	public T defaultCase(EObject object) {
        return null;
    }

} //XcoreSwitch
