package org.eclipse.viatra.query.testing.core.base;

import com.google.inject.Inject;
import com.google.inject.Injector;
import java.util.HashSet;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.viatra.query.patternlanguage.emf.eMFPatternLanguage.PatternModel;
import org.eclipse.viatra.query.runtime.api.IPatternMatch;
import org.eclipse.viatra.query.runtime.api.IQuerySpecification;
import org.eclipse.viatra.query.runtime.api.ViatraQueryEngine;
import org.eclipse.viatra.query.runtime.api.ViatraQueryMatcher;
import org.eclipse.viatra.query.testing.core.ModelLoadHelper;
import org.eclipse.viatra.query.testing.core.SnapshotHelper;
import org.eclipse.viatra.query.testing.core.TestExecutor;
import org.eclipse.viatra.query.testing.core.api.ViatraQueryTest;
import org.eclipse.viatra.query.testing.snapshot.MatchSetRecord;
import org.eclipse.viatra.query.testing.snapshot.QuerySnapshot;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.Extension;
import org.junit.Assert;

/**
 * @deprecated use {@link ViatraQueryTest} API instead
 */
@Deprecated
@SuppressWarnings("all")
public abstract class CommonStaticQueryTester {
  @Inject
  @Extension
  private ModelLoadHelper _modelLoadHelper;
  
  @Inject
  @Extension
  private TestExecutor _testExecutor;
  
  @Inject
  @Extension
  private SnapshotHelper _snapshotHelper;
  
  @Inject
  private Injector injector;
  
  public void testQuery(final String queryFQN) {
    final QuerySnapshot sns = this.snapshot();
    Notifier _eMFRootForSnapshot = this._snapshotHelper.getEMFRootForSnapshot(sns);
    final ViatraQueryEngine engine = this.getEngine(_eMFRootForSnapshot);
    PatternModel _queryInput = this.queryInput();
    final ViatraQueryMatcher matcher = this._modelLoadHelper.initializeMatcherFromModel(_queryInput, engine, queryFQN);
    MatchSetRecord _matchSetRecordForPattern = this._snapshotHelper.getMatchSetRecordForPattern(sns, queryFQN);
    final HashSet<String> results = this._testExecutor.compareResultSets(matcher, _matchSetRecordForPattern);
    String _logDifference = this._testExecutor.logDifference(results);
    HashSet<Object> _newHashSet = CollectionLiterals.<Object>newHashSet();
    Assert.assertArrayEquals(_logDifference, ((Object[])Conversions.unwrapArray(_newHashSet, Object.class)), ((Object[])Conversions.unwrapArray(results, Object.class)));
  }
  
  public void testQuery(final IQuerySpecification queryMF) {
    final QuerySnapshot sns = this.snapshot();
    Notifier _eMFRootForSnapshot = this._snapshotHelper.getEMFRootForSnapshot(sns);
    final ViatraQueryEngine engine = this.getEngine(_eMFRootForSnapshot);
    this.testQuery(engine, sns, queryMF);
  }
  
  public void testQuery(final ViatraQueryEngine engine, final QuerySnapshot sns, final IQuerySpecification queryMF) {
    try {
      final ViatraQueryMatcher matcher = engine.<ViatraQueryMatcher<? extends IPatternMatch>>getMatcher(queryMF);
      String _fullyQualifiedName = queryMF.getFullyQualifiedName();
      MatchSetRecord _matchSetRecordForPattern = this._snapshotHelper.getMatchSetRecordForPattern(sns, _fullyQualifiedName);
      final HashSet<String> results = this._testExecutor.compareResultSets(matcher, _matchSetRecordForPattern);
      String _logDifference = this._testExecutor.logDifference(results);
      HashSet<Object> _newHashSet = CollectionLiterals.<Object>newHashSet();
      Assert.assertArrayEquals(_logDifference, ((Object[])Conversions.unwrapArray(_newHashSet, Object.class)), ((Object[])Conversions.unwrapArray(results, Object.class)));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public ViatraQueryEngine getEngine(final Notifier root) {
    try {
      return ViatraQueryEngine.on(root);
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public QuerySnapshot snapshot() {
    String _snapshotURI = this.snapshotURI();
    QuerySnapshot _loadExpectedResultsFromUri = this._modelLoadHelper.loadExpectedResultsFromUri(_snapshotURI);
    return ((QuerySnapshot) _loadExpectedResultsFromUri);
  }
  
  public PatternModel queryInput() {
    String _queryInputVQLURI = this.queryInputVQLURI();
    Iterable<String> _queryInputDependencyURIs = this.queryInputDependencyURIs();
    PatternModel _loadPatternModelFromUri = this._modelLoadHelper.loadPatternModelFromUri(_queryInputVQLURI, this.injector, ((String[])Conversions.unwrapArray(_queryInputDependencyURIs, String.class)));
    return ((PatternModel) _loadPatternModelFromUri);
  }
  
  public abstract String snapshotURI();
  
  public abstract String queryInputVQLURI();
  
  public abstract Iterable<String> queryInputDependencyURIs();
}
