package org.eclipse.viatra.query.tooling.ui.retevis.util;

import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.rete.recipes.AntiJoinRecipe;
import org.eclipse.viatra.query.tooling.ui.retevis.AntiJoinRecipeMatch;

/**
 * A match processor tailored for the org.eclipse.viatra.query.tooling.ui.retevis.antiJoinRecipe pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class AntiJoinRecipeProcessor implements IMatchProcessor<AntiJoinRecipeMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pRecipe the value of pattern parameter recipe in the currently processed match
   * 
   */
  public abstract void process(final AntiJoinRecipe pRecipe);
  
  @Override
  public void process(final AntiJoinRecipeMatch match) {
    process(match.getRecipe());
  }
}
