package org.eclipse.viatra.query.tooling.ui.retevis.util;

import org.eclipse.viatra.query.runtime.api.IMatchProcessor;
import org.eclipse.viatra.query.runtime.rete.recipes.InputFilterRecipe;
import org.eclipse.viatra.query.tooling.ui.retevis.InputFilterRecipeWithoutMaskMatch;

/**
 * A match processor tailored for the org.eclipse.viatra.query.tooling.ui.retevis.inputFilterRecipeWithoutMask pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class InputFilterRecipeWithoutMaskProcessor implements IMatchProcessor<InputFilterRecipeWithoutMaskMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pRecipe the value of pattern parameter recipe in the currently processed match
   * 
   */
  public abstract void process(final InputFilterRecipe pRecipe);
  
  @Override
  public void process(final InputFilterRecipeWithoutMaskMatch match) {
    process(match.getRecipe());
  }
}
