/**
 * Copyright (c) 2004-2015, Peter Lunk, Zoltan Ujhelyi and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Peter Lunk - initial API and implementation
 */
package org.eclipse.viatra.transformation.debug.adapter.impl;

import org.eclipse.viatra.transformation.debug.adapter.ITransformationAdapter;
import org.eclipse.viatra.transformation.evm.api.Activation;
import org.eclipse.viatra.transformation.evm.api.resolver.ConflictSet;

/**
 * Abstract transformation Adapter class. Newly implemented VIATRA transformation adapters should extend this class.
 * 
 * @author Peter Lunk
 */
@SuppressWarnings("all")
public abstract class AbstractTransformationAdapter implements ITransformationAdapter {
  @Override
  public Activation<?> afterFiring(final Activation<?> activation) {
    return activation;
  }
  
  @Override
  public ConflictSet afterSchedule(final ConflictSet conflictSet) {
    return conflictSet;
  }
  
  @Override
  public Activation<?> beforeFiring(final Activation<?> activation) {
    return activation;
  }
  
  @Override
  public ConflictSet beforeSchedule(final ConflictSet conflictSet) {
    return conflictSet;
  }
  
  @Override
  public void afterTransformation() {
  }
  
  @Override
  public void beforeTransformation() {
  }
}
